exec("./DBCheckGui.gui");
function DBCheckGui::onWake(%this)
{
	if(!%this.firstInit)
	{
		%this.firstInit = 1;
		DBCheckList.removeAll(%this);
		DBCheckList.refreshAddOns(); //Add the add-ons
	}
}

//Removes everything from here
function DBCheckList::removeAll(%this)
{
	%this.deleteAll();
	%this.extent = getWord(%this.minExtent,0) SPC "0";
	%this.position = getWord(%this.position,0) SPC getWord(%this.maxExtent,1)-getWord(%this.extent,1);
	DBMeter.count = 872; //Just in case?
	DBMeter.setDatablockCount(872);
}

function DBCheckList::refreshAddOns(%this)
{
	if(getSimTime() - %this.lastRefresh < 5000) return; //We don't need to spam it, it's gotta load yo
	%this.removeAll();
	%pattern = "Add-Ons/*/server.cs"; //yee
   	%file = findFirstFile(%pattern);
   	while(%file !$= "")
   	{
   		DBCheckList.addRow(strReplace(filePath(%file),"Add-Ons/",""));
    	%file = findNextFile(%pattern);
   	}
}

//Adds another swatch as a loading bar for
function DBCheckList::addRow(%this,%name) //It's a swatch, we need to make some kind of function
{
	%this.resize(getWord(%this.position,0), getWord(%this.position,1), getWord(%this.extent,0) , getWord(%this.extent,1)+25);
	if(strPos(%name,"/") >= 0) return;
	%lolHi = new GuiSwatchCtrl("DBAddOn_" @ %name) 
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 " @ getWord(DBCheckList.extent,1)-25;
		extent = "320 25";
		minExtent = "335 25";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		color = "0 0 0 0";

	    new GuiTextCtrl("DBAddOn_File" @ %name) 
	    {
	        profile = "BlockChatChannelSize0Profile";
	        horizSizing = "right";
	        vertSizing = "bottom";
	        position = "4 0";
	        extent = "225 25";
	        minExtent = "225 25";
	        enabled = "1";
	        visible = "1";
	        clipToParent = "1";
	        text = %name;
	        maxLength = "255";
	        AddOnName = %name;
	    };

	    new GuiBitmapButtonCtrl("DBButton_" @ %name)
	    {
	    	profile = "BlockButtonProfile";
	        horizSizing = "right";
	        vertSizing = "bottom";
	        position = "235 2";
	        extent = "51 20";
	        minExtent = "8 2";
	        enabled = "1";
	        visible = "1";
	        clipToParent = "1";
	        command = "DB_GetAmount(" @ ("DBButton_" @ %name) @ ");";
	        text = "??? DB";
	        groupNum = "-1";
	        buttonType = "PushButton";
	        bitmap = "base/client/ui/button1";
	        lockAspectRatio = "0";
	        alignLeft = "0";
	        alignTop = "0";
	        overflowImage = "0";
	        mKeepCached = "0";
	        mColor = "255 255 255 255";
	        AddOnName = %name;
	    };

	    new GuiCheckBoxCtrl("DBTog_" @ %name) 
	    {
	        profile = "GuiCheckBoxProfile";
	        horizSizing = "right";
	        vertSizing = "bottom";
	        position = "295 0";
	        extent = "13 25";
	        minExtent = "8 2";
	        enabled = "1";
	        visible = "1";
	        clipToParent = "1";
	        command = "";
	        text = "Button";
	        groupNum = "-1";
	        buttonType = "ToggleButton";
	        AddOnName = %name;
	    };
   	};
   	%this.add(%lolHi);
   	("DBTog_" @ %name).command = "DB_SetAddOn(" @ ("DBTog_" @ %name).AddOnName @ "," @ ("DBTog_" @ %name) @ ");";
   	("DBButton_" @ %name).toggler = ("DBTog_" @ %name);
   	if($AddOn__[%name] != -1)
		("DBTog_" @ %name).setValue($AddOn__[%name]);
	schedule(250 + getWord(%this.extent,1) / 25,0,DB_GetAmount,("DBButton_" @ %name));
}

function DBMeter::addDatablockCount(%this,%level){%this.setDatablockCount(%this.getDatablockCount() + %level);}

function DBMeter::setDatablockCount(%this,%level)
{
	%ex = getWord(%this.extent,1);
	%mEx0 = getWord(%this.maxExtent,0);
	%mEx1 = getWord(%this.maxExtent,1);
	//Base game uses 424, 64 color datablocks would be around 448, so we aren't sure if this will be accurate..
	%this.count = %level;
	%c = %this.count;
	if(%c < 0) %this.count = 0;
	else if(%c > 4096) %this.count = 4096;

	%mEx2 = %mEx1 * (%this.count/4096);

	%this.resize(getWord(%this.position,0), 310-%mEx2, %mEx0, %mEx2);
	%ex0 = getWord(%this.extent,0);
	%ex1 = getWord(%this.extent,1);

	%this.color = "0 100 0 100";
	if(%ex1 >= %mEx1){%this.extent = %mEx0 SPC %mEx1; %this.color = "100 0 0 100";}
	if(%ex1 < 0) %this.extent = %mEx0 SPC "0";
	DBMeterWord.setText("<just:center>" @ %this.getDatablockCount() @ "<br>DB(s)");
	return mFloor(%this.count);
}

function DBMeter::getDatablockCount(%this)
{
	return mFloor(%this.count);
}

function DB_GetAmount(%object)
{
	if(!isObject(%object)) return;
	if(!strLen(%n = %object.AddOnName)) return;
	%pattern = "Add-Ons/" @ %n @ "/*.cs";
   	%file = findFirstFile(%pattern);
   	while(%file !$= "")
   	{
   		%stuff++;
   		%datablockCount = 0;
    	%object.fileObject[%stuff] = new FileObject();
    	%object.fileObject[%stuff].openForRead(%file);
    	while(!%object.fileObject[%stuff].isEOF())
    	{
    		%line = %object.fileObject[%stuff].readLine();
    		if(strPos(%line,"datablock ") >= 0)
    			%datablockCount++;
    	}
    	%object.fileObject[%stuff].close();
    	%object.fileObject[%stuff].delete();
    	%file = findNextFile(%pattern);
   	}
   	%object.setText(%datablockCount @ " DB");
   	if(isObject(%obj=%object.toggler) && !%obj.clickedOnce)
   	{
   		%obj.clickedOnce = 1;
   		%obj.datas = %datablockCount;
   		if(%obj.getValue())
   			DBMeter.addDatablockCount(%datablockCount);
   	}
}

function DB_SetAddOn(%name,%obj)
{
	if(!isObject(%obj)) return;
	$AddOn__[%name] = %obj.getValue();
	if($AddOn__[%name])
		DBMeter.addDatablockCount(%obj.datas);
	else
		DBMeter.addDatablockCount(-%obj.datas);
}

function toggleDatablockChecker(%val)
{
	if(%val)
		if(DBCheckGui.isAwake())
			canvas.popdialog(DBCheckGui);
		else
			canvas.pushdialog(DBCheckGui);
}

if(!$addedVisoDatablockChec)
{
	$remapDivision[$remapCount] = "Datablock";
	$remapName[$remapCount] = "Open DB Checker";
	$remapCmd[$remapCount] = "toggleDatablockChecker";
	$remapCount++;
	$addedVisoDatablockChec = true;
}